"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterStyleValues = void 0;
var valueFilters = [
    // prevent injecting additional rules
    /;/,
    // prevent injecting script tags
    /[<>]/,
    // prevent hexadecimal characters
    // (could allow an exploiter to get around the url/expression/javascript rules)
    /\\/,
    /@import/i,
    /expression/i,
    /url/i,
    /javascript/i,
];
function filterStyleValues(dirty) {
    if (dirty === void 0) { dirty = {}; }
    var clean = {};
    Object.keys(dirty).forEach(function (key) {
        var value = String(dirty[key]);
        var unsanitary = valueFilters.some(function (regex) { return regex.test(String(value)); });
        if (unsanitary)
            return;
        clean[key] = value;
    });
    return clean;
}
exports.filterStyleValues = filterStyleValues;
